<template>
  <CForm
    class="result-search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CSelect
          v-model="category"
          :value.sync="category"
          label="カテゴリ"
          horizontal
          :options="[
            { value: 1, label: 'お酒' },
          ]"
          placeholder="選んでください"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'th-list']" class="width-1x" />
          </template>
        </CSelect>
      </div>

      <div class="col-12 col-xl-6">
        <CSelect
          v-model="type"
          :value.sync="type"
          label="分類"
          horizontal
          :options="TYPE_PRODUCT_LIST"
          placeholder="選んでください"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'list']" class="width-1x" />
          </template>
        </CSelect>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="boxId"
          type="text"
          label="箱番"
          placeholder="箱番"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'boxes']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            状態
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group
              v-model="bidResultStatus"
              :list="PRODUCT_RESULT_STATUS_LIST"
              :name="'bidResultStatus'"
            />
          </CCol>
        </div>
      </div>
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="disabled || loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        検索
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        クリア
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  .result-search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>

<script>
import { isEqual } from 'lodash'

import { PRODUCT_RESULT_STATUS_LIST } from '~/constants'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SUBMIT = 'submit'
const TYPE_PRODUCT_LIST = [
  { value: 1, label: 'すべて' },
  { value: 2, label: 'ウイスキー' },
  { value: 3, label: 'ブランデー' },
  { value: 4, label: '果実酒（ワイン）' },
  { value: 5, label: 'スピリッツ' },
  { value: 6, label: '清酒' },
  { value: 7, label: '焼酎' },
  { value: 8, label: 'リキュール' },
  { value: 9, label: 'その他' }
]

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      // Form search
      boxId: null,
      category: null,
      type: null,
      bidResultStatus: 0,

      // Previous codition
      prevCondition: null
    }
  },

  computed: {
    /**
     * Get TYPE_PRODUCT_LIST
     *
     */
    TYPE_PRODUCT_LIST () {
      return TYPE_PRODUCT_LIST
    },

    /**
     * Get PRODUCT_RESULT_STATUS_LIST
     *
     */
    PRODUCT_RESULT_STATUS_LIST () {
      return PRODUCT_RESULT_STATUS_LIST
    },

    /**
     * Check disable status of button search
     *
     * @return {Boolean} Disable status of button search
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }

      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Get condition input on form
     *
     * @return {Object} Condition
     */
    condition () {
      const condition = {}

      if (this.boxId) {
        condition.boxId = this.boxId
      }

      if (this.category) {
        condition.category = this.category
      }

      if (this.type) {
        condition.type = this.type
      }

      if (this.status) {
        condition.status = this.status
      }

      if (this.bidResultStatus) {
        condition.bidResultStatus = this.bidResultStatus
      }

      return condition
    }
  },

  methods: {
    /**
     * Clean all condition data on form
     */
    onClearFormSearch () {
      this.boxId = null
      this.category = null
      this.type = null
      this.bidResultStatus = 0
    },

    /**
     * Check validate input
     * If valid then show error
     * Else call submit event
     */
    onSubmit () {
      this.prevCondition = this.condition
      this.$emit(EVENT_SUBMIT, this.condition)
    }
  }
}
</script>
